"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createBabelConfig;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _fileExists = _interopRequireDefault(require("../utils/fileExists"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Installed inside, i.e., via npm link
let moduleDir = _path.default.resolve(__dirname, '../../node_modules'); // Test if installed as devDependency


if (!(0, _fileExists.default)(_path.default.join(moduleDir, '@babel/preset-env'))) {
  moduleDir = _path.default.resolve(__dirname, '../../..');
}

function createBabelConfig(config = {}) {
  const resolvePaths = {
    extensions: ['.js', '.jsx', '.json', '.ts', '.tsx'],
    root: [moduleDir, ...(config.root ? (Array.isArray(config.root) ? config.root : [config.root]).map(f => _path.default.join(config.bundleRoot, _path.default.relative(config.bundleRoot, f))) : []), _path.default.join(config.bundleRoot, 'node_modules')],
    alias: {
      '@babel/runtime': _path.default.join(moduleDir, '@babel/runtime'),
      ...(config.alias || {})
    },
    ...(config.resolve || {})
  };
  const babelConfig = {
    presets: [config.isServer ? [require.resolve('@babel/preset-env'), {
      'modules': 'commonjs',
      'targets': {
        'node': 'current'
      }
    }] : [require.resolve('@babel/preset-env'), {
      'modules': 'commonjs',
      // Allow config to bundle polyfills instead of relying on global
      ...(config.includePolyfill ? {
        useBuiltIns: 'usage',
        corejs: 3
      } : {}),
      'targets': {
        'browsers': ['last 2 versions', 'ie >= 10']
      }
    }], require.resolve('@babel/preset-react'), require.resolve('@babel/preset-typescript')],
    plugins: [require.resolve('@babel/plugin-proposal-object-rest-spread'), require.resolve('@babel/plugin-proposal-class-properties'), require.resolve('@babel/plugin-proposal-export-default-from'), require.resolve('@babel/plugin-syntax-dynamic-import'), require.resolve('babel-plugin-transform-node-env-inline'), require.resolve('@mna/builder/config/babel-plugin-react-require'), require.resolve('babel-plugin-add-module-exports'), require.resolve('babel-plugin-inline-json-import'), require.resolve('@babel/plugin-transform-modules-commonjs'), ...(config.isServer ? [] : [//https://github.com/babel/babel/tree/master/packages/babel-plugin-transform-runtime
    [require.resolve('@babel/plugin-transform-runtime'), {
      //corejs: 3,
      corejs: false,
      helpers: true,
      regenerator: true //, useESModules: true,

    }]]), [require.resolve('babel-plugin-module-resolver'), resolvePaths]] //extends // Get from config?
    //babelrc: false

  };
  return babelConfig;
}

module.exports = exports.default;