"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _render = _interopRequireDefault(require("./render"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function endsWith(str, search) {
  return str.indexOf(search, str.length - search.length) !== -1;
}

var _default = ({
  types: t
}) => ({
  visitor: {
    ImportDeclaration: {
      exit: function (path, state) {
        const node = path.node;
        if (!endsWith(node.source.value, '.md')) return;

        const dir = _path.default.dirname(_path.default.resolve(state.file.opts.filename));

        const absolutePath = _path.default.resolve(dir, node.source.value);

        const content = _fs.default.readFileSync(absolutePath, "utf8");

        path.replaceWith(t.variableDeclaration('var', [t.variableDeclarator(t.identifier(node.specifiers[0].local.name), t.stringLiteral((0, _render.default)(content)))]));
      }
    }
  }
});

exports.default = _default;
module.exports = exports.default;