"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = clean;

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _chalk = _interopRequireDefault(require("chalk"));

var _getAllBobs = _interopRequireDefault(require("../utils/getAllBobs"));

var _splitDir = _interopRequireDefault(require("../utils/splitDir"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function clean(config) {
  const {
    log,
    relative,
    yesno
  } = config;
  const bob = (0, _getAllBobs.default)(config);
  let folders = [];
  log.title('Clean');
  Object.keys(bob).forEach(key => {
    bob[key].forEach(bundle => {
      if (!bundle.dest) return;
      const folder = (0, _splitDir.default)(bundle.dest).dir;
      if (folders.indexOf(folder) >= 0) return;
      folders.push(folder);
      log(folder);
    });
  });
  if (!yesno(_chalk.default.red('Remove all folders?'))) return;
  const tasks = folders.map(f => emptyDirectory(f));
  return Promise.all(tasks).then(() => log.title('Done'));
}

function emptyDirectory(dir) {
  return new Promise((resolve, reject) => {
    _fsExtra.default.emptyDir(dir, err => {
      if (err) reject(err);else resolve();
    });
  });
}

module.exports = exports.default;