"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = help;

var _getAllBobs = _interopRequireDefault(require("../utils/getAllBobs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function help(config) {
  const {
    log,
    relative
  } = config;
  log.title('Use', 'bob [command]');
  log.title('Commands');
  log('bob dev', '  Build project for development and watch files for changes');
  log('bob build', 'Build project for production');
  log('bob serve', 'Build project and serve static files');
  log('bob clean', 'Remove built files');
  log.title('Current project');
  const allBobs = (0, _getAllBobs.default)(config);
  Object.keys(allBobs).forEach(task => {
    log(task);
    const bundles = allBobs[task].reduce((obj, b) => {
      Object.keys(b).forEach(key => {
        if (!obj[key]) obj[key] = [];
        obj[key].push(b[key]);
      });
      return obj;
    }, {});
    Object.keys(bundles).forEach(key => {
      let value = bundles[key];
      if (!Array.isArray()) value = [value];
      log.info(`    ${key}: ${value.join(', ')}`);
    });
  });
}

module.exports = exports.default;