"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = liveReloadServer;
exports.reload = reload;
exports.reloadCSS = reloadCSS;

var _ws = _interopRequireDefault(require("ws"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let server;
let logger;

function liveReloadServer(options = {}) {
  // Port must be the same in client.js
  const {
    port = 35729,
    log
  } = options;
  logger = log;
  if (!server) server = new _ws.default.Server({
    port
  });
  /*server.on('connection', () => {
    logger && logger('Live reload', 'Connected')
  })*/

  return {
    reload,
    reloadCSS
  };
}

let scheduleReload;

function reload() {
  //clearTimeout(scheduleReload)
  //scheduleReload = setTimeout(() => {
  //logger && logger('Live reload', 'Reload page')
  server && server.clients.forEach(client => {
    client.send(JSON.stringify({
      reload: true
    }));
  }); //}, 1000)
}

function reloadCSS() {
  logger && logger('Live reload', 'Reload CSS');
  server && server.clients.forEach(client => {
    client.send(JSON.stringify({
      reloadCSS: true
    }));
  });
}