"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = babelTask;

var _path = _interopRequireDefault(require("path"));

var _gulp = _interopRequireDefault(require("gulp"));

var _gulpBabel = _interopRequireDefault(require("gulp-babel"));

var _gulpSourcemaps = _interopRequireDefault(require("gulp-sourcemaps"));

var _gulpIf = _interopRequireDefault(require("gulp-if"));

var _config = _interopRequireDefault(require("../babel/config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function babelTask(config) {
  const {
    src,
    dest,
    dev,
    log,
    relative,
    chalk,
    globalIgnore = []
  } = config;
  return new Promise((resolve, reject) => {
    _gulp.default.src([`${src}/**/*.js`].concat(globalIgnore)).pipe((0, _gulpIf.default)(dev, _gulpSourcemaps.default.init())).pipe((0, _gulpBabel.default)((0, _config.default)({ ...config,
      isServer: true
    }))).on('error', function (e) {
      log.error('babel', e.message);
      this.emit('end');
      reject();
    }).pipe((0, _gulpIf.default)(dev, _gulpSourcemaps.default.write())).pipe(_gulp.default.dest(dest)).on('end', () => {
      log('babel', `${relative(src)} -> ${chalk.green(relative(dest))}`);
      resolve();
    });
  });
}

module.exports = exports.default;