"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = babelWatch;

var _path = _interopRequireDefault(require("path"));

var _gulp = _interopRequireDefault(require("gulp"));

var _gulpBabel = _interopRequireDefault(require("gulp-babel"));

var _gulpSourcemaps = _interopRequireDefault(require("gulp-sourcemaps"));

var _gulpIf = _interopRequireDefault(require("gulp-if"));

var _config = _interopRequireDefault(require("../babel/config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import reloadAfterNodemon from '../utils/reloadAfterNodemon'
function babelWatch(config) {
  const {
    src,
    dest,
    dev = false,
    log,
    relative,
    chalk,
    globalIgnore = []
  } = config; // For server-side render to resolve client require

  process.env.NODE_PATH = process.env.NODE_PATH || dest; // Watch & compile each changed file
  // Doesn't return promise because it never stops

  return _gulp.default.watch([`${src}/**/*.js`].concat(globalIgnore)).on('change', filePath => {
    return _gulp.default.src(filePath, {
      base: src
    }).pipe((0, _gulpIf.default)(dev, _gulpSourcemaps.default.init())).pipe((0, _gulpBabel.default)((0, _config.default)(config))).on('error', function (e) {
      log.error('babel', e.message);
      this.emit('end');
    }).pipe((0, _gulpIf.default)(dev, _gulpSourcemaps.default.write())).pipe(_gulp.default.dest(dest)).on('end', () => {
      log('babel', `${relative(filePath)} -> ${chalk.green(relative(dest))}`); // Reload client
      //reloadAfterNodemon()
    });
  });
}

module.exports = exports.default;