"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = copyTask;

var _path = _interopRequireDefault(require("path"));

var _gulp = _interopRequireDefault(require("gulp"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function copyTask({
  src,
  dest,
  root,
  dev,
  log,
  relative,
  chalk,
  globalIgnore = []
}) {
  return new Promise((resolve, reject) => {
    _gulp.default.src([src].concat(globalIgnore)).on('error', function (e) {
      log.error('copy', e.message);
      this.emit('end');
      reject();
    }).pipe(_gulp.default.dest(dest)).on('end', () => {
      log('copy', `${relative(src)} -> ${chalk.green(relative(dest))}`);
      resolve();
    });
  });
}

module.exports = exports.default;