"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = copyTask;

var _path = _interopRequireDefault(require("path"));

var _gulp = _interopRequireDefault(require("gulp"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function copyTask({
  src,
  dest,
  root,
  dev,
  log,
  relative,
  chalk,
  globalIgnore = []
}) {
  return _gulp.default.watch([`${src}/**/*`].concat(globalIgnore)).on('change', filePath => {
    return _gulp.default.src(filePath, {
      base: src
    }).on('error', function (e) {
      log.error('copy', e.message);
      this.emit('end');
    }).pipe(_gulp.default.dest(dest)).on('end', () => {
      log('copy', `${relative(filePath)} -> ${chalk.green(relative(dest))}`);
    });
  });
}

module.exports = exports.default;