"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = htmlTask;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _gulp = _interopRequireDefault(require("gulp"));

var _gulpReplace = _interopRequireDefault(require("gulp-replace"));

var _gulp2 = _interopRequireDefault(require("../ejt/gulp"));

var _fileExists = _interopRequireDefault(require("../utils/fileExists"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import ejs from 'gulp-ejs'
function htmlTask(config) {
  const {
    src,
    dest,
    dev,
    livereload = false,
    electron = false,
    log,
    relative,
    chalk,
    globalIgnore = []
  } = config;
  /*if (!fileExists(src)) {
    log.error('html', `File doesn't exist: ${src}`)
    return Promise.resolve()
  }*/

  const srcParts = src.split('/');
  let srcRoot = '';

  for (let part of srcParts) {
    if (part[0] === '*' || part.indexOf('.') >= 0) break;
    srcRoot += part + '/';
  } // Pass source root for HTML template includes


  srcRoot = _path.default.join(process.cwd(), srcRoot);
  const script = createScript({
    dev,
    livereload,
    electron
  });
  return new Promise(function (resolve, reject) {
    _gulp.default.src([`${src}`].concat(globalIgnore), {
      allowEmpty: true
    }).pipe((0, _gulp2.default)({
      ext: '.html',
      srcRoot
    })).on('error', function (e) {
      log.error('html', e);
      this.emit('end');
      resolve(); //reject()
    }).on('end', () => {
      log('html', `${relative(src)} -> ${chalk.green(relative(dest))}`);
      resolve();
    }).pipe((0, _gulpReplace.default)('</body>', `${script}</body>`)).pipe(_gulp.default.dest(dest));
  });
}

function createScript({
  dev,
  livereload,
  electron
}) {
  let script = '';

  if (dev && livereload) {
    const liveReloadClient = _fs.default.readFileSync(_path.default.join(__dirname, '../live-reload/client.js'), 'utf-8');

    script = `<script>${liveReloadClient}</script>`;
  } else if (electron) {
    script = `<script>electron = require('electron');${// TODO: Load the script directly from file
    dev ? `require(process.cwd()+'/electron-connect').client.create()` : ''}</script>`;
  }

  return script;
}

module.exports = exports.default;