"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = startNodemon;

var _gnodemon = _interopRequireDefault(require("../utils/gnodemon"));

var _chalk = _interopRequireDefault(require("chalk"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function startNodemon({
  src,
  watch,
  port = 3000,
  log,
  relative,
  reload
}) {
  log('nodemon', `Serve from ${relative(src)}: type ${_chalk.default.green('rs')} and enter to restart`); // Doesn't return promise because it never stops

  (0, _gnodemon.default)({
    script: src,
    watch: watch,
    ignore: ['.git', 'node_modules'],
    args: [`--port="${port}"`] // , `--exec "node --trace-warnings --pending-deprecation"`
    //env: {'NODE_ENV': 'development'},
    // Show deprecation warnings with stack trace
    // https://nodejs.org/en/docs/guides/buffer-constructor-deprecation/
    //execMap: { js: 'node --trace-warnings --pending-deprecation' }

  }) //.on('error', (e) => { log.error(e.stack) })
  .on('error', function (e) {
    log.error('nodemon', e.message);
    this.emit('end');
  }).on('restart', () => {
    log('nodemon', 'Restart'); //if (reload) setTimeout(reload, 500)
  }); //.on('exit', () => {})
  // Kill nodemon process on Ctrl/Cmd + C

  process.once('SIGINT', function () {
    process.exit();
  });
}

module.exports = exports.default;