"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _path = _interopRequireDefault(require("path"));

var _http = _interopRequireDefault(require("http"));

var _nodeStatic = _interopRequireDefault(require("node-static"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default({
  src,
  port = 3000,
  dev = false,
  log,
  relative,
  chalk
}) {
  // Reference: https://github.com/cloudhead/node-static
  const staticServer = new _nodeStatic.default.Server(src, {
    cache: !dev,
    headers: dev ? {
      'Cache-Control': 'no-cache,must-revalidate,max-age=0'
    } : {}
  });

  _http.default.createServer((req, res) => {
    req.addListener('end', () => {
      staticServer.serve(req, res, e => {
        if (e && e.status === 404) {
          staticServer.serveFile('index.html', 200, {}, req, res);
        }
      });
    }).resume();
  }).listen(port);

  log('static', `Serving at ${chalk.green('http://localhost:' + port)} from ${relative(src)}`);
}

module.exports = exports.default;