"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getPackageJSON;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _fileExists = _interopRequireDefault(require("./fileExists"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getPackageJSON(config) {
  const {
    root
  } = config;

  const packagePath = _path.default.join(root, 'package.json');

  const bobConfigPath = _path.default.join(root, 'bob.config.js');

  let json = {};

  try {
    if ((0, _fileExists.default)(packagePath)) {
      try {
        json = JSON.parse(_fs.default.readFileSync(packagePath, 'utf8'));
      } catch (e) {//
      }
    }

    if ((0, _fileExists.default)(bobConfigPath)) {
      json.bob = require(bobConfigPath)(config);
    }
  } catch (e) {
    console.log(e);
  }

  return json;
}

module.exports = exports.default;