"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createLogger;

var _chalk = _interopRequireDefault(require("chalk"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createLogger(options) {
  let log = (name, ...args) => {
    options.verbose && console.log(`  ${_chalk.default.blue(name)}`, ...args);
  };

  log.title = (name, ...args) => {
    options.verbose && console.log(_chalk.default.green(name) + (args.length ? ':' : ''), ...args);
  };

  log.info = (...args) => {
    options.verbose && console.log(...args);
  };

  log.error = (name, ...args) => {
    console.error(`  ${_chalk.default.red(name)}`, ...args);
  };

  return log;
}

module.exports = exports.default;